USE [msdb]
GO
Set NoCount ON;
/*
Version: 2.1 du 20/03/2023

Ce script permet de supprimer les objets requis par le LOG SHIPPING !
Il doit tre utilis uniquement  la fin de la migration pour nettoyer les serveurs source et cible.
*/
IF  EXISTS (SELECT * FROM sys.synonyms WHERE name = N'syn_DbFilesLocation' AND schema_id = SCHEMA_ID(N'LogShip'))
Begin
	DROP SYNONYM [LogShip].[syn_DbFilesLocation]
End
GO
IF  EXISTS (SELECT * FROM sys.synonyms WHERE name = N'syn_up_Set_LogShipping_ON' AND schema_id = SCHEMA_ID(N'LogShip'))
Begin
	DROP SYNONYM [LogShip].[syn_up_Set_LogShipping_ON]
End
GO
IF  EXISTS (SELECT * FROM sys.synonyms WHERE name = N'syn_sp_add_schedule' AND schema_id = SCHEMA_ID(N'LogShip'))
Begin
	DROP SYNONYM [LogShip].[syn_sp_add_schedule]
End
GO
IF  EXISTS (SELECT * FROM sys.synonyms WHERE name = N'syn_DatabasesDetails' AND schema_id = SCHEMA_ID(N'LogShip'))
Begin
	DROP SYNONYM [LogShip].[syn_DatabasesDetails]
End
GO
IF  EXISTS (SELECT * FROM sys.synonyms WHERE name = N'syn_sysjobs' AND schema_id = SCHEMA_ID(N'LogShip'))
Begin
	DROP SYNONYM [LogShip].[syn_sysjobs]
End
GO
IF  EXISTS (SELECT * FROM sys.synonyms WHERE name = N'syn_sysschedules' AND schema_id = SCHEMA_ID(N'LogShip'))
Begin
	DROP SYNONYM [LogShip].[syn_sysschedules]
End
GO
IF  EXISTS (SELECT * FROM sys.synonyms WHERE name = N'syn_sp_delete_log_shipping_secondary_database' AND schema_id = SCHEMA_ID(N'LogShip'))
Begin
	DROP SYNONYM [LogShip].[syn_sp_delete_log_shipping_secondary_database]
End
GO
IF  EXISTS (SELECT * FROM sys.synonyms WHERE name = N'syn_up_Restore_LogShipping_DB' AND schema_id = SCHEMA_ID(N'LogShip'))
Begin
	DROP SYNONYM [LogShip].[syn_up_Restore_LogShipping_DB]
End
GO

IF  EXISTS (SELECT * FROM sys.synonyms WHERE name = N'syn_sp_add_log_shipping_secondary_primary' AND schema_id = SCHEMA_ID(N'LogShip'))
Begin
	DROP SYNONYM [LogShip].[syn_sp_add_log_shipping_secondary_primary]
End
GO

IF  EXISTS (SELECT * FROM sys.synonyms WHERE name = N'syn_sp_add_log_shipping_secondary_database' AND schema_id = SCHEMA_ID(N'LogShip'))
Begin
	DROP SYNONYM [LogShip].[syn_sp_add_log_shipping_secondary_database]
End
GO

IF  EXISTS (SELECT * FROM sys.synonyms WHERE name = N'syn_log_shipping_secondary' AND schema_id = SCHEMA_ID(N'LogShip'))
Begin
	DROP SYNONYM [LogShip].[syn_log_shipping_secondary]
End
GO

IF  EXISTS (SELECT * FROM sys.synonyms WHERE name = N'syn_sp_add_log_shipping_secondary_database' AND schema_id = SCHEMA_ID(N'LogShip'))
Begin
	DROP SYNONYM [LogShip].[syn_sp_add_log_shipping_secondary_database]
End
GO

IF  EXISTS (SELECT * FROM sys.synonyms WHERE name = N'syn_sp_update_job' AND schema_id = SCHEMA_ID(N'LogShip'))
Begin
	DROP SYNONYM [LogShip].[syn_sp_update_job]
End
GO

IF  EXISTS (SELECT * FROM sys.synonyms WHERE name = N'syn_sp_delete_job' AND schema_id = SCHEMA_ID(N'LogShip'))
Begin
	DROP SYNONYM [LogShip].[syn_sp_delete_job]
End
GO

IF  EXISTS (SELECT * FROM sys.synonyms WHERE name = N'syn_sp_attach_schedule' AND schema_id = SCHEMA_ID(N'LogShip'))
Begin
	DROP SYNONYM [LogShip].[syn_sp_attach_schedule]
End
GO
IF  EXISTS (SELECT * FROM sys.synonyms WHERE name = N'syn_sp_start_job' AND schema_id = SCHEMA_ID(N'LogShip'))
Begin
	DROP SYNONYM [LogShip].[syn_sp_start_job]
End
GO
IF  EXISTS (SELECT * FROM sys.synonyms WHERE name = N'syn_up_WaitRunningJob' AND schema_id = SCHEMA_ID(N'LogShip'))
Begin
	DROP SYNONYM [LogShip].[syn_up_WaitRunningJob]
End
GO
IF  EXISTS (SELECT * FROM sys.synonyms WHERE name = N'syn_sf_IsRunningJob' AND schema_id = SCHEMA_ID(N'LogShip'))
Begin
	DROP SYNONYM [LogShip].[syn_sf_IsRunningJob]
End
GO
IF OBJECT_ID('LogShip.up_Set_LogShipping_ON') is not null
Begin
	Drop procedure LogShip.up_Set_LogShipping_ON
End
GO
IF OBJECT_ID('LogShip.up_WaitRunningJob') is not null
Begin
	Drop procedure LogShip.up_WaitRunningJob
End
GO
IF OBJECT_ID('LogShip.up_Set_LogShipping_OFF') is not null
Begin
	Drop procedure LogShip.up_Set_LogShipping_OFF
End
GO
IF OBJECT_ID('LogShip.up_Restore_LogShipping_DB') is not null
Begin
	Drop procedure LogShip.up_Restore_LogShipping_DB
End
GO
IF OBJECT_ID('LogShip.v_ObjectsScripts') is not null
Begin
	Drop view LogShip.v_ObjectsScripts;
End
GO
IF object_id('LogShip.InstanceLoginsRoles') is not null
Begin
	Drop table LogShip.InstanceLoginsRoles;
End
GO
IF OBJECT_ID('LogShip.LogShipObjects') is not null
Begin
	Drop table [LogShip].LogShipObjects
End
GO
IF object_id('LogShip.DbFilesLocation') is not null
Begin
	Drop table LogShip.DbFilesLocation;
End
GO
IF OBJECT_ID('LogShip.LogShipParams') is not null
Begin
	Drop table LogShip.LogShipParams
End
GO
IF OBJECT_ID('LogShip.DatabasesDetails') is not null
Begin
	Drop TABLE [LogShip].[DatabasesDetails]
End
GO
IF OBJECT_ID('LogShip.sf_hexadecimal') is not null
BEGIN
	Drop function [LogShip].[sf_hexadecimal]
End
GO
IF OBJECT_ID('LogShip.sf_ObjectDefinition') is not null
Begin
	Drop function [LogShip].[sf_ObjectDefinition]
End
GO
IF OBJECT_ID('LogShip.sf_IsRunningJob') is not null
Begin
	Drop function [LogShip].[sf_IsRunningJob]
End
GO
IF OBJECT_ID('dbo.STRING_SPLIT') is not null
Begin
	Drop function dbo.STRING_SPLIT
End
GO
IF Exists(Select top 1 1 from sys.schemas Where name = 'LogShip')
Begin
	Exec('Drop SCHEMA [LogShip];')
End
GO
IF Exists(SELECT job_id FROM msdb.dbo.sysjobs WHERE name = 'SoSql_LogShip_Restore_All_DB')
Begin
	EXEC msdb.dbo.sp_delete_job @job_name=N'SoSql_LogShip_Restore_All_DB', @delete_unused_schedule=1
End

IF Exists(SELECT job_id FROM msdb.dbo.sysjobs WHERE name = 'SoSql_LogShip_Backup_All_DB')
Begin
	EXEC msdb.dbo.sp_delete_job @job_name=N'SoSql_LogShip_Backup_All_DB', @delete_unused_schedule=1
End

IF Exists(SELECT job_id FROM msdb.dbo.sysjobs WHERE name = 'SoSql_LogShip_Copy_All_DB')
Begin
	EXEC msdb.dbo.sp_delete_job @job_name=N'SoSql_LogShip_Copy_All_DB', @delete_unused_schedule=1
End

IF Exists(select top 1 1 from sys.servers where is_linked = 1 and (Upper(name) = UPPER('LogShipLinkedServer') Or Upper(data_source) = UPPER('LogShipLinkedServer')))
Begin
	EXEC master.dbo.sp_dropserver @server='LogShipLinkedServer'
End
